/*

Event Triggers library created by ACWraith on October 20, 2007.

This library is made to help automate actions.
The difference between this library and my previous event libraries
is that events in this library double as their own triggers.
As with Event Datums, events will performed in the order in which they were added.

Consider the prefix et_ to be reserved.

See demo.dm for a test application.

/////////////////////////////////////////////////////////////////////////////////////////////////
datum

et_Add(et_Event/Event,Merge=TRUE)
	Add Event to the datum.
	If Merge then attempt to merge with the first matching et_Event.
	Otherwise, Event is added to the end.
	Returns TRUE on success.

et_ClearEvents()
	Remove all events.
	Returns TRUE if there were any events to remove.

et_CopyEventsTo(datum/Clone)
	Add all of src's events to Clone.
	Returns TRUE if there were events and they were all copied.

et_GetAddMatches(et_Event/Match)
	Returns all events that are merge candidates with Match.

et_GetPerformMatches(et_Event/Match)
	Returns all events that would be performed when Match is performed.

et_GetRemoveMatches(et_Event/Match)
	Returns all events that are removal candidates with Match.

et_PerformEvents(et_Event/Match,Arguments)
	Perform all events that match Match.
	Arguments is for you to pass information to the events.

et_Remove(et_Event/Event)
	Remove the first et_Event that matches Event.

/////////////////////////////////////////////////////////////////////////////////////////////////
et_Event

New(Trigger)
	Trigger is is the identifier for when the event should be performed.

et_AddMerge(et_Event/Event)
	Merge Event with src.
	You must define this type of merging yourself.
	Returns whether or not the merge happened.
	By default, this simply returns FALSE.

et_Copy()
	Returns an et_Event which is a copy of the event.
	By default, it is src's type with the same trigger.
	The copy is what is actually added to datums.
	Remember to define any extra vars in the derivatives.

et_GetTrigger()
	Returns the event's trigger.

et_MatchesAdd(et_Event/Event)
	Returns whether not Event could be merged with src.
	By default, this returns TRUE if the triggers are the same.

et_MatchesPerform(et_Event/Event)
	Returns whether not src performs when Event is performed.
	By default, this returns TRUE if the triggers are the same.

et_MatchesRemove(et_Event/Event)
	Returns whether or not Eventidentifies src for removal.
	By default, this returns TRUE if Event is src.

et_Perform(Source,Arguments)
	Source should perform the event.
	Should return TRUE on success.
	By default, this returns FALSE because defining what happens is the entire point.
	Arguments is whatever information you passed in through datum.et_PerformEvents().

SetTrigger(Trigger)
	Returns TRUE if the trigger was set to Trigger.
	(This is a way to reuse identifying events.)

*/