//	Let's create an event type.
et_Event/TalkToSelf

	//============================================================================================
	var
		speech	= "Are you an idiot who doesn't understand that this library is for more than text?"
		times	= 0

	//============================================================================================
	//--------------------------------------------------------------------------------------------
	New(Trigger,Speech,Times)
		..(Trigger)
		if (Speech)	src.speech	= Speech
		if (Times)	src.times	= Times

	//--------------------------------------------------------------------------------------------
	//	The new vars will have to be duplicated in the copy.
	et_Copy()
		var/et_Event/TalkToSelf/result	= ..()
		result.speech					= src.speech
		result.times					= src.times
		return result

	//--------------------------------------------------------------------------------------------
	//	Let's allow merges in order to modify a var.
	et_AddMerge(et_Event/Event)
		if ( src.et_MatchesAdd(Event) )
			var/et_Event/TalkToSelf/TTS	= Event
			src.times					+= TTS.times
			return TRUE
		return FALSE

	//--------------------------------------------------------------------------------------------
	//	Some vars can't be modified.
	//	We'll want to make sure that they match before merging.
	et_MatchesAdd(et_Event/Event)
		.		= ..(Event)
		if (.)
			var/et_Event/TalkToSelf/TTS	= Event
			.	= (TTS.speech == src.speech)

	//--------------------------------------------------------------------------------------------
	//	With the default match, you have to send in the same et+Event you want to be removed.
	//	You have access to it.  It might not even be there to remove.
	//	Create a way to identify
	et_MatchesRemove(et_Event/Event)
		//	Match the triggers.
		if ( !istype(Event) || (Event.et_GetTrigger() != src.et_GetTrigger()) )	return FALSE
		//	Match the identifying variables you created.
		var/et_Event/TalkToSelf/TTS	= Event
		return (TTS.speech == src.speech)

	//--------------------------------------------------------------------------------------------
	//	Your event should do something!
	//	Make sure to define this proc.
	et_Perform(Source,Arguments)
		//	Now see how stupid this sample event is? ;)
		if ( ismob(Source) )
			for(var/index = 1 to src.times)	Source	<< "You say to yourself: [src.speech]"
		else
			for(var/index = 1 to src.times)	world	<< "[Source] says to \himself: [src.speech]"
		return TRUE

/////////////////////////////////////////////////////////////////////////////////////////////////

/*
	Any datum can hold et_Events.
	We'll use a mob for this demo and then copy its events to an obj.
*/

mob

	//============================================================================================
	verb
		//----------------------------------------------------------------------------------------
		self_add_TalkToSelf(Trigger as text, Speech as text, Times as num)
			set desc	= "(Trigger,Speech,Times) During Trigger, say Speech Times more times."

			//	Create a new event and add it.
			//	By default, events that can be merged will be.
			if ( src.et_Add(new/et_Event/TalkToSelf(Trigger,Speech,Times)) )
				src	<< "When [Trigger] is triggered, you should say [Speech] to yourself [Times] (more?) time\s."

		//----------------------------------------------------------------------------------------
		self_clear_events()
			set desc	= "Remove all of your events."
			if ( src.et_ClearEvents() )	src	<< "Your events have been cleared."

		//----------------------------------------------------------------------------------------
		self_perform_events(Trigger as text)
			set desc	= "(Trigger) Activate your Trigger."

			//	Create an et_Event to match.
			//	By default, event performances are identified by their trigger.
			//	You might use more (or different) variables in your derivatives.
			//	For this reason, an entire et_Event is used to match.
			//	You would just store the variables in there.
			var/et_Event/E						= new(Trigger)

			//	We don't use any event arguments in this demo so we don't need to pass them in.
			if ( src.et_PerformEvents(E,null) )	src	<< "Your [Trigger] has been fully triggered."

		//----------------------------------------------------------------------------------------
		self_remove_TalkToSelf(Trigger as text, Speech as text)
			set desc	= "(Trigger,Speech) During Trigger, remove the first et_Event with Speech."

			//	We only need the identifying variables for our matching event.
			var/et_Event/TalkToSelf/E	= new(Trigger,Speech)

			if ( src.et_Remove(E) )
				src	<< "When [Trigger] is triggered, you should no longer say [Speech] to yourself."
			else
				src	<< "You have [length(src.et_GetPerformMatches(E))] event\s for trigger [Trigger]."

/*
	This obj is provided just to have something to copy to.
*/

	//============================================================================================
	var/obj/eventSum

	//============================================================================================
	verb
		//----------------------------------------------------------------------------------------
		eventSum_copy_events_from_self()
			set desc	= "Add your events to eventSum."
			//	This bit is just to initialize for the demo.
			if (!src.eventSum)
				src.eventSum		= new
				src.eventSum.name	= "Event Sum"

			//	Note that we copy TO datums rather than from them.
			//	Also note that we are actually adding events.
			//	If we copy twice then twice the events will be added.
			if ( src.et_CopyEventsTo(src.eventSum) )
				src	<< "Your events have been copied to Event Sum."

		//
		//	The following are just repeats of the above used for the eventSum.
		//

		//----------------------------------------------------------------------------------------
		eventSum_clear_events()
			set desc	= "Remove all of eventSum's events."
			if (src.eventSum && src.eventSum.et_ClearEvents())
				src	<< "Event Sum's events have been cleared."

		//----------------------------------------------------------------------------------------
		eventSum_perform_events(Trigger as text)
			set desc	= "(Trigger) Activate eventSum's Trigger."
			if (!src.eventSum)	return

			var/et_Event/E						= new(Trigger)
			if ( src.eventSum.et_PerformEvents(E,null) )
				src	<< "Event Sum's [Trigger] has been fully triggered."

