et_Event

	//============================================================================================
	var
		et_trigger
		et_Event/et_nextEvent

	//============================================================================================
	//--------------------------------------------------------------------------------------------
	New(Trigger)
		src.et_trigger	= Trigger

	//--------------------------------------------------------------------------------------------
	Del()
		src.et_nextEvent	= null
		..()


	//============================================================================================
	proc
		//----------------------------------------------------------------------------------------
		//	Merge Event with src.
		//	You must define this type of merging yourself.
		//	Returns whether or not the merge happened.
		//	By default, this simply returns FALSE.
		et_AddMerge(et_Event/Event)
			return FALSE

		//----------------------------------------------------------------------------------------
		//	Returns an et_Event which is a copy of the event.
		//	By default, it is src's type with the same trigger.
		//	The copy is what is actually added to datums.
		//	Remember to define any extra vars in the derivatives.
		et_Copy()
			return new src.type (src.et_GetTrigger())

		//----------------------------------------------------------------------------------------
		//	Returns the event's trigger.
		et_GetTrigger()
			return src.et_trigger

		//----------------------------------------------------------------------------------------
		//	Returns whether not Event could be merged with src.
		//	By default, this returns TRUE if the triggers are the same.
		et_MatchesAdd(et_Event/Event)
			return ( istype(Event) && (src.et_GetTrigger() == Event.et_GetTrigger()) )

		//----------------------------------------------------------------------------------------
		//	Returns whether not src performs when Event is performed.
		//	By default, this returns TRUE if the triggers are the same.
		et_MatchesPerform(et_Event/Event)
			return ( istype(Event) && (src.et_GetTrigger() == Event.et_GetTrigger()) )

		//----------------------------------------------------------------------------------------
		//	Returns whether or not Eventidentifies src for removal.
		//	By default, this returns TRUE if Event is src.
		et_MatchesRemove(et_Event/Event)
			return (Event == src)

		//----------------------------------------------------------------------------------------
		//	Source should perform the event.
		//	Should return TRUE on success.
		//	By default, this returns FALSE because defining what happens is the entire point.
		//	Arguments is whatever information you passed in through datum.et_PerformEvents().
		et_Perform(Source,Arguments)
			return FALSE

		//----------------------------------------------------------------------------------------
		//	Returns TRUE if the trigger was set to Trigger.
		//	(This is a way to reuse identifying events.)
		SetTrigger(Trigger)
			src.et_trigger	= Trigger
			return TRUE